<template>
  <b-container>
    <div class="container-input">
      <b-dropdown :text="typeResearch" left variant="outline-primary" class="btn-outline">
        <b-dropdown-item @click="chooseResearch('Hashtag')" value="hashtag">Hashtag</b-dropdown-item>
        <b-dropdown-item @click="chooseResearch('Parola chiave')" value="chiave">Parola chiave</b-dropdown-item>
        <b-dropdown-item @click="chooseResearch('Utente')" value="utente">Utente specifico</b-dropdown-item>
      </b-dropdown>
      <b-form-input class="input-margin" v-model="keyword" :placeholder="typeResearch"></b-form-input>
      <b-button variant="outline-primary" class="my-2 my-sm-0 btn-outline" type="submit" @click="search()">Cerca</b-button>
      <b-button variant="outline-primary" class="my-2 my-sm-0 btn-outline" @click="openFilter()"><b-icon class="filter" icon="filter"></b-icon></b-button>
    </div>
    <div class="container-data" v-if="filter">
      <div>
        <label for="start-datepicker">Data di inizio</label>
        <b-form-datepicker id="start-datepicker" v-model="start_date" :min="this.twitterstart" :max="end_date" class="mb-2"></b-form-datepicker>
      </div>
      <div>
        <label for="end-datepicker">Data di fine</label>
        <b-form-datepicker id="end-datepicker" v-model="end_date" :min="this.twitterstart" :max="max" class="mb-2"></b-form-datepicker>
      </div>
    </div>
    <div class="container-tabs">
      <b-tabs content-class="mt-3" align="center">
        <b-tab title="Timeline" active @click="clickedTab('timeline')">
          <b-button variant="outline-primary" class="my-2 my-sm-0 btn-outline" type="submit" @click="stream()"><b-icon icon="play-circle"></b-icon>Live</b-button>
          <b-button v-if="isstreaming" variant="danger" class="my-2 my-sm-0" type="submit" @click="abort()"><b-icon icon="stop-circle"></b-icon>Stop</b-button>
          <div v-if="showData">
            <SpinnerComponent v-if="loading"></SpinnerComponent>
            <div v-if="!loading && (tweetsids?.length > 0)" class="container-tweet">
              <Tweet :id="item" :key="item" v-for="item in tweetsids"></Tweet>
              <b-button variant="outline-primary" class="my-2 my-sm-0 btn-outline" @click="more()" v-if="searchnexttoken!=''">Altro</b-button>
            </div>
          </div>
          <div v-if="!showData" class="container-tweet">
            <Tweet id="1597643052633698304"><SpinnerComponent></SpinnerComponent></Tweet>
          </div>
          <div v-if="inputEmpty" class="container-tweet">
            <Tweet id="1595054526989565952"><SpinnerComponent></SpinnerComponent></Tweet>
          </div>
          <div v-if="genericError" class="container-tweet">
            <Tweet id="1595053740725538817"><SpinnerComponent></SpinnerComponent></Tweet>
          </div>
        </b-tab>
        <b-tab title="Mappa" @click="clickedTab('map')">
          <SpinnerComponent v-if="loading"></SpinnerComponent>
          <MapComponent v-if="(showMap && (dataToMap != undefined) && !loading && !genericError && !inputEmpty)" :data="dataToMap"></MapComponent>
          <div v-if="genericError && !loading" class="container-tweet">
            <Tweet id="1595053740725538817"><SpinnerComponent></SpinnerComponent></Tweet>
          </div>
          <div v-if="!showMap" class="container-tweet">
            <Tweet id="1597643052633698304"><SpinnerComponent></SpinnerComponent></Tweet>
          </div>
          <div v-if="inputEmpty" class="container-tweet">
            <Tweet id="1595054526989565952"><SpinnerComponent></SpinnerComponent></Tweet>
          </div>
        </b-tab>
        <b-tab title="Frequenza" @click="clickedTab('graph')">
          <SpinnerComponent v-if="loading"></SpinnerComponent>
          <BarChartComponent id="barchart" v-if="showBarChart && !loading && !genericError"/>
          <div v-if="genericError" class="container-tweet">
            <Tweet id="1595053740725538817"><SpinnerComponent></SpinnerComponent></Tweet>
          </div>
          <div v-if="!showBarChart" class="container-tweet">
            <Tweet id="1597643052633698304"><SpinnerComponent></SpinnerComponent></Tweet>
          </div>
        </b-tab>
        <b-tab title="Sentiment" @click="clickedTab('cake')">
          <SpinnerComponent v-if="loading"></SpinnerComponent>
          <PieChartComponent id="piechart" v-if="(showPieChart && !loading && !genericError && !inputEmpty)"/>
          <div v-if="genericError" class="container-tweet">
            <Tweet id="1595053740725538817"><SpinnerComponent></SpinnerComponent></Tweet>
          </div>
          <div v-if="!showPieChart" class="container-tweet">
            <Tweet id="1597643052633698304"><SpinnerComponent></SpinnerComponent></Tweet>
          </div>
          <div v-if="inputEmpty" class="container-tweet">
            <Tweet id="1595054526989565952"><SpinnerComponent></SpinnerComponent></Tweet>
          </div>
        </b-tab>
        <b-tab title="Word Cloud" @click="clickedTab('cloud')">
          <SpinnerComponent v-if="loading"></SpinnerComponent>
          <WordCloudComponent :words="dataWords" id="wordcloud" v-if="showWordCloud && !loading && !genericError"/>
          <div v-if="genericError" class="container-tweet">
            <Tweet id="1595053740725538817"><SpinnerComponent></SpinnerComponent></Tweet>
          </div>
          <div v-if="!showWordCloud" class="container-tweet">
            <Tweet id="1597643052633698304"><SpinnerComponent></SpinnerComponent></Tweet>
          </div>
        </b-tab>
      </b-tabs>
    </div>
  </b-container>
</template>

<script>
import axios from 'axios'
import { latLng } from "leaflet";
import SpinnerComponent from '../components/SpinnerComponent.vue'
import { Tweet } from 'vue-tweet-embed'

const sentiment = require("wink-sentiment");

export default {
  components: {
    BarChartComponent: () => import("../components/BarChartComponent.vue"),
    MapComponent: () => import("../components/MapComponent.vue"),
    PieChartComponent: () => import("../components/PieChartComponent.vue"),
    WordCloudComponent: () => import("../components/WordCloudComponent.vue"),
    SpinnerComponent, 
    Tweet
  },
  mounted() {
    const plugin = document.createElement("script");
    plugin.setAttribute(
      "src",
      "https://platform.twitter.com/widgets.js"
    );
    plugin.async = true;
    document.head.appendChild(plugin);
  },
  data () {
      const now = new Date()
      const today = this.pad(now.getFullYear()) + "-" + this.pad(now.getMonth() + 1) + "-" + this.pad(now.getDate())
      const maxDate = today
      const minDate = this.pad(now.getFullYear()) + "-" + this.pad(now.getMonth()) + "-" + this.pad(now.getDate())
      const twitterBirthday = new Date()
      twitterBirthday.setDate(26)
      twitterBirthday.setMonth(3)
      twitterBirthday.setFullYear(2006)
    return {
      keyword: '',
      tweet: '',
      info: '',
      min : minDate,
      max : maxDate,
      end_date: maxDate,
      start_date: minDate,
      twitterstart: twitterBirthday,
      dataToMap: [],
      loading: false,
      tweetsids: [],
      typeResearch: 'Parola chiave',
      filter: false,
      showBarChart: true,
      showPieChart: true,
      showWordCloud: false,
      showMap: false,
      showData: false,
      inputEmpty: false,
      genericError: false,
      tabActive: 'timeline',
      searchnexttoken: '',
      next_token: 'empty',
      isstreaming: false,
      abortController: new AbortController(),
      query: '',
      dataWords: []
    }
  },
  methods: {
    search: async function() {
      this.searchnexttoken = ''
      this.loading = true;
      this.genericError = false;
      if(this.keyword == '' || this.keyword == ' ' || this.keyword == undefined || this.keyword == null) {
        this.inputEmpty = true;
        this.loading = false;
      } else {
        this.inputEmpty = false;
        if(this.tabActive == 'timeline') {
          return this.timeline();
        } else if(this.tabActive == 'map') {
          return this.maps();
        } else if(this.tabActive == 'graph') {
          return this.countDay();
        } else if (this.tabActive == 'cake') {
          return this.sentiment();
        } else if (this.tabActive == 'cloud') {
          return this.cloud();
        }
      }
      
    },
    clickedTab(tab) {
      this.tabActive = tab;
    },
    stream: async function() {
      this.tweetsids = []
      this.isstreaming = true;
      this.genericError = false;
      let done = false
      if(this.keyword == '' || this.keyword == undefined || this.keyword == null) {
        this.inputEmpty = true;
      } else {
        this.inputEmpty = false;
      }
      if(this.typeResearch == 'Utente') {
        this.query = "from:" + this.keyword
      }  if(this.typeResearch == 'Hashtag') {
        this.query = "#" + this.keyword
      }  if (this.typeResearch == 'Parola chiave') {
        this.query = this.keyword
      }

     fetch("http://localhost:8000/api/v1/stream/"+this.keyword, { signal: this.abortController.signal })
      .then(async (res) => {
        const reader = res.body.getReader()
        let buffer = ''

        while (!done) {
          const result = await reader.read()
          done = done || result.done
          buffer += new TextDecoder().decode(result.value)

            let curlyCount = 0
            let insideQuotes = false

            for (let i = 0; i < buffer.length; i++) {
              if (buffer[i] === '\\') {
                i += 1
                if (i >= buffer.length) {
                  break
                }
                continue
              }
              if (buffer[i] === '"') {
                insideQuotes = !insideQuotes
              }

              if (!insideQuotes) {
                if (buffer[i] === '{') {
                  curlyCount++
                }

                if (buffer[i] === '}') {
                  curlyCount--

                  if (curlyCount === 0) {
                    const decodedTweet = JSON.parse(buffer.substring(0, i + 1))
                    buffer = buffer.substring(i + 1)
                    i = -1
                    if (!decodedTweet.type || decodedTweet.type !== 'keep-alive') {
                      this.showData = true 
                      this.tweetsids.unshift(decodedTweet.data.id)
                    } else {
                      console.log('keep-alive')
                    }
                  }
                }
              }
            }
      }
    })
    },
    timeline: async function() {
      this.loading = true;
      this.tabActive = 'timeline';
      this.genericError = false;
      if(this.typeResearch == 'Utente') {
        return this.user();
      } else if(this.typeResearch == 'Hashtag') {
        return this.hashtagCall();
      } else if (this.typeResearch == 'Parola chiave') {
        this.tweetsids = [];
        this.tweet = [];
        let res = await axios.get("http://localhost:8000/api/v1/search/"+this.keyword+"/"+this.start_date+"/"+this.end_date+"/"+this.next_token)
        .catch(() => {
            this.loading = false;
            this.genericError = true;
          });
        if(res.data == undefined || res.data.data == undefined) {
          this.genericError = true;
        } else {
          this.showData = true;
          this.tweet = res.data;
        }
        if(Object.prototype.hasOwnProperty.call(res.data.meta, "next_token")){
          this.searchnexttoken = res.data.meta.next_token
        }
        this.parseids(res)
      }
      await this.$nextTick()
      this.loading = false;
    },
    user: async function() {
      this.loading = true;
      this.genericError = false;
      this.tweetsids = [];
      this.tweet = [];
      let res = await axios.get("http://localhost:8000/api/v1/searchbyuser/"+this.keyword+"/"+this.start_date+"/"+this.end_date+"/"+this.next_token)
      .catch(() => {
          this.loading = false;
          this.genericError = true;
        });
      if(res.data == undefined || res.data.data == undefined) {
        this.genericError = true;
      } else {
        this.showData = true;
        this.tweet = res.data;
      }
      if(Object.prototype.hasOwnProperty.call(res.data.meta, "next_token")){
            this.searchnexttoken = res.data.meta.next_token
      } 
      console.log(res.data)
      this.parseids(res)
      await this.$nextTick()
      this.loading = false;
    },
    hashtagCall: async function() {
      this.loading = true;
      this.genericError = false;
      this.tweetsids = [];
      this.tweet = [];
      let res = await axios.get("http://localhost:8000/api/v1/searchbyhashtag/"+this.keyword+"/"+this.start_date+"/"+this.end_date+"/"+this.next_token)
      .catch(() => {
        this.loading = false;
        this.genericError = true;
      });
      if(res.data == undefined || res.data.data == undefined) {
        this.genericError = true;
      } else {
        this.showData = true;
        this.tweet = res.data
      }
      if(Object.prototype.hasOwnProperty.call(res.data.meta, "next_token")){
            this.searchnexttoken = res.data.meta.next_token
        } 
      this.parseids(res)
      await this.$nextTick()
      this.loading = false;
    },
    convertForSentiment: function() {
      if (this.tweet.length == 0) { return ([0,0,0]) }
      let positive = 0; let neutral = 0; let negative = 0;
      for (let tweet of this.tweet) {
        let s = sentiment(tweet.text).normalizedScore
        if (s > 0) { positive++ }
        else if (s < 0) { negative++ }
        else { neutral++ }
      }
      return ([positive, neutral, negative])
    },
    sentiment: async function() {
      this.loading = true
      this.tabActive = 'cake'
      this.genericError = false
      let typeResearch, res, positive = 0, neutral = 0, negative = 0
      if (this.typeResearch == 'Parola chiave') { typeResearch = "sentiment" }
      else if (this.typeResearch == 'Hashtag') { typeResearch = "sentimentbyhashtag" }
      else if (this.typeResearch == 'Utente') { typeResearch = "sentimentbyuser" }
      else { this.genericError = true }
      this.next_token = 'empty'
      let check
      do {
        res = await this.callApi(typeResearch)
        if(res == undefined || res.data == undefined || res.data.data == undefined) {
          this.genericError = true;
          this.loading = false;
        }
        this.tweet = res.data.data
        let tmp = this.convertForSentiment()
        positive += tmp[0]
        neutral += tmp[1]
        negative += tmp[2]

        check = Object.prototype.hasOwnProperty.call(res.data.meta, 'next_token')
        if (check) { this.next_token = res.data.meta.next_token }
      } while (!this.genericError && check)
      this.loading = false

      const counts = [positive, neutral, negative]
      this.$root.$emit("getDataPieChart", (counts))
    },
    cloud: async function() {
      this.loading = true
      this.tabActive = 'cloud'
      this.genericError = false
      let res = await axios.get("http://localhost:8000/api/v1/getwordcloud/"+this.keyword+"/"+this.start_date+"/"+this.end_date)
      .catch(() => {
        this.loading = false;
        this.genericError = true;
      });
      this.dataWords = res.data
      this.loading = false;
      this.$root.$emit("getDataWordCloud", (res.data))
      this.showWordCloud = true;
    },
    convertForCountDay: function() {
      let result = []
      for (const info of this.tweet) {
        let data = info.start.substring(0,10)
        let n_tweets = info.tweet_count
        let temp = [data, n_tweets]
        result.push(temp)
      }
      return (result)
    },
    countDay: async function() {
      this.loading = true;
      this.tabActive = 'graph';
      this.genericError = false;
      let typeResearch
      if (this.typeResearch == 'Parola chiave') { typeResearch = "countday" }
      else if (this.typeResearch == 'Hashtag') { typeResearch = "countdaybyhashtag" }
      else if (this.typeResearch == 'Utente') { typeResearch = "countdaybyuser" }
      else { this.genericError = true }
      this.next_token = 'empty'
      let res
      let result = []
      let check
      do {
        res = await this.callApi(typeResearch)
        if(res == undefined || res.data == undefined || res.data.data == undefined) {
          this.genericError = true;
        }
        this.tweet = res.data.data
        result = this.convertForCountDay().concat(result)
        check = Object.prototype.hasOwnProperty.call(res.data.meta, 'next_token')
        if (check) { this.next_token = res.data.meta.next_token }
        else { this.next_token = "" }
      } while (!this.genericError && check)
      this.showBarChart = true
      this.$root.$emit("getDataBarChart", (result))
      await this.$nextTick()
      this.loading = false;
    },
    callApi: async function (research) {
      let res = await axios.get("http://localhost:8000/api/v1/" +research+"/"+this.keyword+"/"+this.start_date+"/"+this.end_date+"/"+this.next_token)
      .catch(() => {
        this.loading = false;
        this.genericError = true;
      })
      return res
    },
    pad: function(number) {
      let r = String(number);
      if (r.length === 1) {
        r = '0' + r;
      }
      return r;
    },
    maps: async function() {
      this.loading = true;
      this.tabActive = 'map';
      this.genericError = false;
      this.markerLatLng = [];
      let res 
      if(this.typeResearch == 'Hashtag') {
        res = await axios.get("http://localhost:8000/api/v1/searchgeobyhashtag/"+this.keyword+"/"+this.start_date+"/"+this.end_date)
        .catch(() => {
          this.loading = false;
          this.genericError = true;
        });
      } else if(this.typeResearch == 'Utente') {
        res = await axios.get("http://localhost:8000/api/v1/searchgeobyuser/"+this.keyword+"/"+this.start_date+"/"+this.end_date)
        .catch(() => {
          this.loading = false;
          this.genericError = true;
        });
      } else {
        res = await axios.get("http://localhost:8000/api/v1/searchgeo/"+this.keyword+"/"+this.start_date+"/"+this.end_date)
        .catch(() => {
          this.loading = false;
          this.genericError = true;
        });
      }
      if(res.data == undefined || res.data.data == undefined) {
        this.genericError = true;
      } else {
        for(let i=0; i< res?.data?.data?.length; i++ ) {
          let id = res?.data?.data[i]?.geo.place_id;
          let geolocation = await axios.get("http://localhost:8000/api/v1/place/"+id)
            .catch(() => {
              this.loading = false;
              this.genericError = true;
            });
          if(res.data == undefined) {
            this.genericError = true;
          }
          this.markerLatLng = this.markerLatLng.concat(latLng(geolocation?.data?.centroid[1],geolocation?.data?.centroid[0]))
        }
        this.dataToMap = this.markerLatLng;
        this.showMap = true;
        await this.$nextTick()
      }
      this.loading = false;
    },
    more: async function(){
      const typeResearch = this.typeResearch
      let res
      if (typeResearch == "Parola chiave") {
        res = await axios.get("http://localhost:8000/api/v1/search/"+this.keyword+"/"+this.start_date+"/"+this.end_date+"/"+this.searchnexttoken)
      .catch(() => {
            this.loading = false;
            this.genericError = true;
          });
      }
      else if (typeResearch == "Hashtag") {
        res = await axios.get("http://localhost:8000/api/v1/searchbyhashtag/"+this.keyword+"/"+this.start_date+"/"+this.end_date+"/"+this.searchnexttoken)
      .catch(() => {
            this.loading = false;
            this.genericError = true;
          });
      }
      else if (typeResearch == "Utente") {
        res = await axios.get("http://localhost:8000/api/v1/searchbyuser/"+this.keyword+"/"+this.start_date+"/"+this.end_date+"/"+this.searchnexttoken)
      .catch(() => {
            this.loading = false;
            this.genericError = true;
          });
      }
      if(res.data == undefined || res.data.data == undefined) {
          this.genericError = true;
        }
      this.parseids(res)
      if(Object.prototype.hasOwnProperty.call(res.data.meta, "next_token")){
        this.searchnexttoken = res.data.meta.next_token
      } 
      else{
        this.searchnexttoken = ''
      }
    },
    parseids: function (result){
      for (let i = 0; i < result?.data?.data?.length; i=i+1 ){
        this.tweetsids.push(result.data?.data[i]?.id)
      }
    },
    chooseResearch(res) {
      this.typeResearch = res;
    },
    openFilter(){
      this.filter = !this.filter;
    },
    abort: function(){
      this.abortController.abort()
      this.isstreaming = false
    }
   }

}
</script>

<style scoped>
.container {
  margin: 2rem auto;
}
.container-input {
  display: flex;
  align-items: center;
}
.container-data {
  margin: 2rem auto;
  text-align: left;
  display: flex;
  align-items: center;
  justify-content: space-evenly;
}
.input-margin {
  margin-right: 0.5rem;
}
.btn-outline {
  margin-right: 0.5rem;
}
.container-tabs {
  margin: 2rem auto;
}
/* .container-tweet {
  display: grid;
  grid-template-columns: 49% 49%;
  width: 100%;
  column-gap: 2%;
  margin: 0 auto;
} */
.container-tweet>div {
  width: 100%;
}
::v-deep .container-tweet .twitter-tweet.twitter-tweet-rendered {
  margin: 2rem auto!important;
  max-width: 40%!important;
}
.btn svg {
  margin-right: 0.5rem;
}
.btn svg.filter {
  margin-right: 0px;
}
</style>
